Index: palm/trunk/SOURCE/bulk_cloud_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 3784)
+++ palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 3786)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! unsed variables removed
+! 
+! 3767 2019-02-27 08:18:02Z raasch
 ! unused variable for file index removed from rrd-subroutines parameter list
 ! 
@@ -723,5 +726,5 @@
 
        USE statistics,                                                         &
-           ONLY: hom, statistic_regions, pr_palm
+           ONLY: hom, statistic_regions
 
        IMPLICIT NONE
@@ -821,7 +824,4 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i !<
-       INTEGER(iwp) ::  j !<
-       INTEGER(iwp) ::  k !<
 !
 !--    Liquid water content
@@ -893,5 +893,4 @@
        INTEGER(iwp) ::  i !<
        INTEGER(iwp) ::  j !<
-       INTEGER(iwp) ::  k !<
 
        CALL location_message( 'initializing bulk cloud module', .FALSE. )
Index: palm/trunk/SOURCE/indoor_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/indoor_model_mod.f90	(revision 3784)
+++ palm/trunk/SOURCE/indoor_model_mod.f90	(revision 3786)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! unused variables removed
+! 
+! 3759 2019-02-21 15:53:45Z suehring
 ! - Calculation of total building volume
 ! - Several bugfixes
@@ -161,11 +164,4 @@
 
     INTEGER(iwp) ::  num_build   !< total number of buildings in domain
-
-    REAL(wp) ::  volume_fraction
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  t_in     !< dummy array for indoor temperature for the 
-                                                     !< total building volume at each discrete height level
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  t_in_l   !< dummy array for indoor temperature for the 
-                                                     !< local building volume fraction at each discrete height level
 
 !
@@ -205,8 +201,8 @@
     REAL(wp) ::  phi_sol                     !< [W] solar loads
     REAL(wp) ::  phi_st                      !<! [W] mass specific thermal load implied non thermal mass 
-    REAL(wp) ::  q_emission                  !< emissions, in first version = 0, option for second part of the project
+!    REAL(wp) ::  q_emission                  !< emissions, in first version = 0, option for second part of the project
     REAL(wp) ::  q_wall_win                  !< heat flux from indoor into wall/window
     REAL(wp) ::  q_waste_heat                !< waste heat, sum of waste heat over the roof to Palm
-    REAL(wp) ::  q_waste_heat_bldg           !< [W/building] waste heat of the complete building, in Palm sum of all indoor_model-calculations
+!    REAL(wp) ::  q_waste_heat_bldg           !< [W/building] waste heat of the complete building, in Palm sum of all indoor_model-calculations
     REAL(wp) ::  schedule_d                  !< activation for internal loads (low or high + low)
     REAL(wp) ::  skip_time_do_indoor = 0.0_wp  !< [s] Indoor model is not called before this time
@@ -222,6 +218,5 @@
     REAL(wp) ::  theta_s                     !<! [degree_C] surface temperature of the RC-node
     REAL(wp) ::  time_indoor = 0.0_wp        !< [s] time since last call of indoor model
-    REAL(wp) ::  time_utc_hour               !< Time in hours per day (UTC)
-    REAL(wp) ::  ventilation_int_loads       !< Zuteilung der GebÃ€ude fÃŒr Verlauf/AktivitÃ€t der LÃŒftung und internen Lasten
+!    REAL(wp) ::  time_utc_hour               !< Time in hours per day (UTC)
     
     REAL(wp) ::  f_sr                        !< [-] factor surface reduction
@@ -405,5 +400,4 @@
 
     INTEGER(iwp) ::  bt   !< local building type
-    INTEGER(iwp) ::  fa   !< running index for facade elements of each building
     INTEGER(iwp) ::  i    !< running index along x-direction
     INTEGER(iwp) ::  j    !< running index along y-direction
@@ -434,6 +428,4 @@
     INTEGER(iwp), DIMENSION(0:numprocs-1) ::  num_buildings_l       !< number of buildings with different ID on local subdomain
     
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  local_weight   !< dummy representing fraction of local on total building volume, 
-                                                           !< height dependent
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  volume         !< total building volume at each discrete height level
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  volume_l       !< total building volume at each discrete height level,
@@ -984,10 +976,4 @@
     USE arrays_3d,                                                             &
         ONLY:  ddzw, dzw
-
-    USE basic_constants_and_equations_mod,                                     &
-        ONLY:  c_p
-
-    USE control_parameters,                                                    &
-        ONLY:  rho_surface
 
     USE date_and_time_mod,                                                     &
Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 3784)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 3786)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! further unused variables removed
+! 
+! 3767 2019-02-27 08:18:02Z raasch
 ! unused variable for file index removed from rrd-subroutines parameter list
 ! 
@@ -2584,7 +2587,5 @@
 
        INTEGER(iwp) ::  i                       !< running index
-       INTEGER(iwp) ::  i_off                   !< index offset of surface element, seen from atmospheric grid point 
        INTEGER(iwp) ::  j                       !< running index
-       INTEGER(iwp) ::  j_off                   !< index offset of surface element, seen from atmospheric grid point 
        INTEGER(iwp) ::  k                       !< running index
        INTEGER(iwp) ::  kn                      !< running index
@@ -6561,5 +6562,4 @@
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i                 !< 
     INTEGER(iwp) ::  k                 !< 
     INTEGER(iwp) ::  l                 !< running index surface orientation
@@ -7262,5 +7262,5 @@
        IMPLICIT NONE
 
-       INTEGER(iwp)                          :: i, j, k, l, m   !< running indices
+       INTEGER(iwp)                          :: i, j, k, m   !< running indices
 
 
Index: palm/trunk/SOURCE/mod_particle_attributes.f90
===================================================================
--- palm/trunk/SOURCE/mod_particle_attributes.f90	(revision 3784)
+++ palm/trunk/SOURCE/mod_particle_attributes.f90	(revision 3786)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! interoperable C datatypes introduced in particle type to avoid compiler warnings
+! 
+! 3720 2019-02-06 13:19:55Z knoop
 ! time_prel replaced by last_particle_release_time
 ! 
@@ -217,31 +220,37 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE     ::  log_z_z0   !< Precalculate LOG(z/z0)
 
-
+!
+!-- WARNING: For compatibility of derived types, the BIND attribute is required, and interoperable C
+!-- datatypes must be used. These type are hard wired here! So changes in working precision (wp, iwp)
+!-- will not affect the particle_type!
+!-- The main reason for introducing the interoperable datatypes was to avoid compiler warnings of
+!-- the gfortran compiler.
+!-- The BIND attribite is required because of C_F_POINTER usage in the pmc particle interface.
     TYPE, BIND(C) ::  particle_type
-        REAL(wp)     ::  aux1          !< auxiliary multi-purpose feature
-        REAL(wp)     ::  aux2          !< auxiliary multi-purpose feature
-        REAL(wp)     ::  radius        !< radius of particle
-        REAL(wp)     ::  age           !< age of particle
-        REAL(wp)     ::  age_m         !<
-        REAL(wp)     ::  dt_sum        !<
-        REAL(wp)     ::  e_m           !< interpolated sgs tke
-        REAL(wp)     ::  origin_x      !< origin x-position of particle (changed cyclic bc)
-        REAL(wp)     ::  origin_y      !< origin y-position of particle (changed cyclic bc)
-        REAL(wp)     ::  origin_z      !< origin z-position of particle (changed cyclic bc)
-        REAL(wp)     ::  rvar1         !<
-        REAL(wp)     ::  rvar2         !<
-        REAL(wp)     ::  rvar3         !<
-        REAL(wp)     ::  speed_x       !< speed of particle in x
-        REAL(wp)     ::  speed_y       !< speed of particle in y
-        REAL(wp)     ::  speed_z       !< speed of particle in z
-        REAL(wp)     ::  weight_factor !< weighting factor
-        REAL(wp)     ::  x             !< x-position
-        REAL(wp)     ::  y             !< y-position
-        REAL(wp)     ::  z             !< z-position
-        INTEGER(iwp) ::  class         !< radius class needed for collision
-        INTEGER(iwp) ::  group         !< number of particle group
-        INTEGER(idp) ::  id            !< particle ID (64 bit integer)
+        REAL(C_DOUBLE) ::  aux1          !< auxiliary multi-purpose feature
+        REAL(C_DOUBLE) ::  aux2          !< auxiliary multi-purpose feature
+        REAL(C_DOUBLE) ::  radius        !< radius of particle
+        REAL(C_DOUBLE) ::  age           !< age of particle
+        REAL(C_DOUBLE) ::  age_m         !<
+        REAL(C_DOUBLE) ::  dt_sum        !<
+        REAL(C_DOUBLE) ::  e_m           !< interpolated sgs tke
+        REAL(C_DOUBLE) ::  origin_x      !< origin x-position of particle (changed cyclic bc)
+        REAL(C_DOUBLE) ::  origin_y      !< origin y-position of particle (changed cyclic bc)
+        REAL(C_DOUBLE) ::  origin_z      !< origin z-position of particle (changed cyclic bc)
+        REAL(C_DOUBLE) ::  rvar1         !<
+        REAL(C_DOUBLE) ::  rvar2         !<
+        REAL(C_DOUBLE) ::  rvar3         !<
+        REAL(C_DOUBLE) ::  speed_x       !< speed of particle in x
+        REAL(C_DOUBLE) ::  speed_y       !< speed of particle in y
+        REAL(C_DOUBLE) ::  speed_z       !< speed of particle in z
+        REAL(C_DOUBLE) ::  weight_factor !< weighting factor
+        REAL(C_DOUBLE) ::  x             !< x-position
+        REAL(C_DOUBLE) ::  y             !< y-position
+        REAL(C_DOUBLE) ::  z             !< z-position
+        INTEGER(C_INT) ::  class         !< radius class needed for collision
+        INTEGER(C_INT) ::  group         !< number of particle group
+        INTEGER(C_LONG_LONG) ::  id            !< particle ID (64 bit integer)
         LOGICAL(C_BOOL) ::  particle_mask !< if this parameter is set to false the particle will be deleted
-        INTEGER(iwp) ::  block_nr      !< number for sorting (removable?)
+        INTEGER(C_INT) ::  block_nr      !< number for sorting (removable?)
     END TYPE particle_type
 