Index: palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_cbm4/chem_gasphase_mod.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_cbm4/chem_gasphase_mod.f90	(revision 3780)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_cbm4/chem_gasphase_mod.f90	(revision 3789)
@@ -97,6 +97,4 @@
                                                                  
                                                                  
-  INTEGER, DIMENSION(vl_dim)  :: kacc, krej                       
-  INTEGER, DIMENSION(vl_dim)  :: ierrv                           
   LOGICAL                     :: data_loaded = .FALSE.             
 ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -115,6 +113,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Parameters.f90
-! Time                 : Tue Mar  5 11:50:49 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190305/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Fri Mar  8 19:00:59 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190308/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -222,6 +220,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Global.f90
-! Time                 : Tue Mar  5 11:50:49 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190305/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Fri Mar  8 19:00:59 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190308/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -251,6 +249,4 @@
 ! TEMP - Temperature
   REAL(kind=dp):: temp
-! TSTART - Integration start time
-  REAL(kind=dp):: tstart
 ! ATOL - Absolute tolerance
   REAL(kind=dp):: atol(nvar)
@@ -291,6 +287,6 @@
 ! 
 ! File                 : chem_gasphase_mod_JacobianSP.f90
-! Time                 : Tue Mar  5 11:50:49 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190305/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Fri Mar  8 19:00:59 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190308/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -387,6 +383,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Monitor.f90
-! Time                 : Tue Mar  5 11:50:49 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190305/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Fri Mar  8 19:00:59 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190308/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -550,6 +546,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Initialize.f90
-! Time                 : Tue Mar  5 11:50:49 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190305/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Fri Mar  8 19:00:59 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190308/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -576,6 +572,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Integrator.f90
-! Time                 : Tue Mar  5 11:50:49 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190305/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Fri Mar  8 19:00:59 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190308/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -634,6 +630,6 @@
 ! 
 ! File                 : chem_gasphase_mod_LinearAlgebra.f90
-! Time                 : Tue Mar  5 11:50:49 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190305/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Fri Mar  8 19:00:59 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190308/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -661,6 +657,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Jacobian.f90
-! Time                 : Tue Mar  5 11:50:49 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190305/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Fri Mar  8 19:00:59 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190308/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -688,6 +684,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Function.f90
-! Time                 : Tue Mar  5 11:50:49 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190305/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Fri Mar  8 19:00:59 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190308/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -717,6 +713,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Rates.f90
-! Time                 : Tue Mar  5 11:50:49 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190305/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Fri Mar  8 19:00:59 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190308/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -743,6 +739,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Util.f90
-! Time                 : Tue Mar  5 11:50:49 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190305/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Fri Mar  8 19:00:59 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190308/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -864,5 +860,5 @@
 
 
-  INTEGER         :: j, k
+ INTEGER         :: k
 
   INTEGER :: i
@@ -908,5 +904,4 @@
    INTEGER       :: icntrl(20), istatus(20), ierr
 
-   INTEGER, SAVE :: ntotal = 0
 
    icntrl(:) = 0
@@ -2261,5 +2256,5 @@
   REAL(dp), DIMENSION(:), INTENT(IN):: c
 
-  write(6,*) 'ERROR in chem_gasphase_mod ',ierr,C(1)
+  write(6,*) 'ERROR in chem_gasphase_mod ',ierr,C(1),PE
 
 
@@ -3570,6 +3565,5 @@
                                                                       
     INTEGER  :: ier                                                   
-    REAL(kind=dp):: jvs(lu_nonzero), w(nvar), a             
-    INTEGER  :: k, kk, j, jj                                          
+    REAL(kind=dp):: jvs(lu_nonzero), a                         
                                                                       
     a = 0.                                                            
@@ -3986,5 +3980,4 @@
   INTEGER, DIMENSION(20)                :: istatus_u               
   INTEGER                                :: ierr_u                  
-  INTEGER                                :: istatf                  
   INTEGER                                :: vl_dim_lo               
                                                                     
@@ -4023,5 +4016,5 @@
                                                                     
    IF (PRESENT(l_debug) .AND. PRESENT(pe)) THEN                       
-      IF (l_debug) CALL error_output(conc(is, :), ierr_u, pe)          
+      IF (l_debug) CALL error_output(conc(is, :), ierr_u, pe)           
    ENDIF                                                              
                                                                       